﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using System.Collections;

namespace STMBench7.Backend
{
	/**
	 * The interface of the core part of the "backbone" of the STMBench7 benchmark --
	 * indexes used by many of the benchmark operations.
	 */
	[Atomic]
	public interface Index : IEnumerable {

		[ReadOnly]
	    Object Get(Object key);
		
		[Update]
	    void Put(Object key, Object value);
	    
		[Update]
	    Object PutIfAbsent(Object key, Object value);
	    
	    [Update]
	    bool Remove(Object key);
	    
	    [ReadOnly]
        IEnumerable /*Iterable<V>*/ GetRange(IndexKey minKey, IndexKey maxKey);
	}

}
