﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Compatability;

namespace STMBench7.Backend
{
	/**
	 * Value of an index key (Index). Could have been just the
	 * Comparable interface, but a.greaterThan(b) is much more
	 * clear than (a.compareTo(b) > 0). Indexes (key values) are 
	 * always immutable, so they do not have to be synchronized.
	 */
	[Immutable]
	public interface IndexKey : IComparable {

	    bool GreaterThan(IndexKey otherIndexKey);
	    bool LowerThan(IndexKey otherIndexKey);
	    bool Equals(IndexKey otherIndexKey);
	}

}
