﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using System.Collections;

namespace STMBench7.Backend
{
	/**
	 * A large set: of the size in the order of at least
	 * a few hundreds of elements. Used by a composite part
	 * to hold the set of child atomic parts, and by the
	 * AtomicPart.buildDate index to hold all atomic parts
	 * with the same build date.
	 */
	[Atomic]
	public interface LargeSet : IEnumerable /*Iterable<E>*/ {

		[Update]
		bool Add(Object element);
		
		[Update]
		bool Remove(Object element);
		
		[ReadOnly]
		bool Contains(Object element);
		
		[ReadOnly]
		int Size();
	}

}
