﻿using System;
using System.Collections;
using STMBench7.Core;

namespace STMBench7.Compatability
{
    /*
     * Because Bartok lacks HashSet<T>
     */
    public class HashtableSet : IEnumerable
    {
        GenomeHashtable impl = new GenomeHashtable();

        public int Count
        {
            get
            {
                return impl.Count;
            }
        }

        public bool Add(Object element)
        {
            if (impl.Contains(element)) return false;
            impl.Add(element, null);
            return true;
        }

        public bool Remove(Object element)
        {
            if (!impl.Contains(element)) return false;
            impl.Remove(element);
            return true;
        }

        public bool Contains(Object element)
        {
            return impl.Contains(element);
        }

        //public IEnumerator<E> GetEnumerator()
        //{
        //    return impl.Keys.Cast<E>().GetEnumerator();
        //}

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return impl.GetEnumerator();
        }

        protected IEnumerator GetEnumerator()
        {
            return impl.GetEnumerator();
        }
    }
}
