﻿using System;
 
 

using System.Text;
using System.Threading;

namespace STMBench7.Compatability
{
    /* Wraps the C# implemention with the Java interface for porting 
     * convience.  Hopefully this is a behavior preserving transformation.
     * 
     */
    public class ReentrantReadWriteLock
    {
        private Lock r,w;

        public ReentrantReadWriteLock(bool fair) //ReaderWriterLock doesn't have a fairness policy?
        {
            ReaderWriterLock implLock = new ReaderWriterLock();
            r = new ReaderLock(implLock);
            w = new WriterLock(implLock);
        }

        public Lock ReadLock()
        {
            return r;
        }
        public Lock WriteLock()
        {
            return w;
        }

        public class ReaderLock : Lock
        {
            private ReaderWriterLock implLock;
            public ReaderLock(ReaderWriterLock implLock)
            {
                this.implLock = implLock;
            }
            public void Lock()
            {
                implLock.AcquireReaderLock(-1); //forever
            }
            public void Unlock()
            {
                implLock.ReleaseReaderLock();
            }
        }
        public class WriterLock : Lock
        {
            private ReaderWriterLock implLock;
            public WriterLock(ReaderWriterLock implLock)
            {
                this.implLock = implLock;
            }
            public void Lock()
            {
                implLock.AcquireWriterLock(-1); //forever
            }
            public void Unlock()
            {
                implLock.ReleaseWriterLock();
            }
        }
    }
}
