﻿using System;
using System.Text;

namespace STMBench7.Compatability
{
    public class ReentrantReadWriteLockAlt
    {
        private Lock r, w;

        public ReentrantReadWriteLockAlt(bool fair) //ReaderWriterLock doesn't have a fairness policy?
        {
            ReaderWriterLockAlt implLock = new ReaderWriterLockAlt();
            r = new ReaderLock(implLock);
            w = new WriterLock(implLock);
        }

        public Lock ReadLock()
        {
            return r;
        }
        public Lock WriteLock()
        {
            return w;
        }

        public class ReaderLock : Lock
        {
            private ReaderWriterLockAlt implLock;
            public ReaderLock(ReaderWriterLockAlt implLock)
            {
                this.implLock = implLock;
            }
            public void Lock()
            {
                implLock.EnterReadLock();
            }
            public void Unlock()
            {
                implLock.ExitReadLock();
            }
        }
        public class WriterLock : Lock
        {
            private ReaderWriterLockAlt implLock;
            public WriterLock(ReaderWriterLockAlt implLock)
            {
                this.implLock = implLock;
            }
            public void Lock()
            {
                implLock.EnterWriteLock();
            }
            public void Unlock()
            {
                implLock.ExitWriteLock();
            }
        }
    }
}
