﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Core
{

    /**
     * Part of the main benchmark data structure. For a default
     * implementation, see stmbench7.impl.core.AtomicPartImpl.
     */
    [Atomic]
    public interface AtomicPart : DesignObj , IComparable/*<AtomicPart>*/
    {
        [Update]
        void ConnectTo(AtomicPart destination, String type, int length);

        [Update]
        void AddConnectionFromOtherPart(Connection connection);
 
        [Update]
        void SetCompositePart(CompositePart partOf);

        [ReadOnly]
        int GetNumToConnections();

        [ReadOnly]
        ImmutableCollection/*<Connection>*/ GetToConnections();

        [ReadOnly]
        ImmutableCollection/*<Connection>*/ GetFromConnections();

        [ReadOnly]
        CompositePart GetPartOf();

        [Update]
        void SwapXY();

        [ReadOnly]
        int GetX();

        [ReadOnly]
        int GetY();

        [Update]
        void ClearPointers();

    }
}
