﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;

namespace STMBench7.Core
{
	/**
	 * Methods for constructing common attributes of objects implementing parts of
	 * the data structure.
	 */
	[Immutable]
	public abstract class DesignObjBuilder {

		protected readonly DesignObjFactory designObjFactory = DesignObjFactory.instance;

        protected virtual String CreateType()
        {
			String type = "type #" + ThreadRandom.NextInt(Parameters.NumTypes);
			return type;
		}

        protected virtual int CreateBuildDate(int minBuildDate, int maxBuildDate)
        {
			return minBuildDate
					+ ThreadRandom.NextInt(maxBuildDate - minBuildDate + 1);
		}

        protected virtual String CreateText(int textSize, String textPattern)
        {
			int patternSize = textPattern.Length;
			int size = 0;
			StringBuilder stringBuilder = new StringBuilder(textSize);

			while (size + patternSize <= textSize) {
				stringBuilder.Append(textPattern);
				size += patternSize;
			}

			return stringBuilder.ToString();
		}
	}

}
