﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Core
{
	/**
	 * Integer index value type (immutable).
	 */
	[Immutable]
	public class IntIndexKey : BaseIndexKey {
	    
	    private readonly int value;

	    public IntIndexKey(int value) {
	    	this.value = value;
	    }

        public override int CompareTo(Object otherIndexKey)
        {
            IntIndexKey otherIntIndexKey = (IntIndexKey)otherIndexKey;

            if (this.value < otherIntIndexKey.value) return -1;
            if (this.value > otherIntIndexKey.value) return 1;
            return 0;
        }

        public override String ToString()
        {
	    	//return Integer.ToString(value);
            return value.ToString();
	    }
	}

}
