﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;

namespace STMBench7.Core
{

    /**
     * Part of the main benchmark data structure. For a default
     * implementation, see stmbench7.impl.core.ManualImpl.
     */
    [Atomic]
    public interface Manual
    {
        	[ReadOnly]
	    int GetId();
	
	[ReadOnly]
	String GetTitle();
	
	[ReadOnly]
	String GetText();
	
	[ReadOnly]
	Module GetModule();
	
	[Update]
	void SetModule(Module module);

	[ReadOnly]
	int CountOccurences(char ch);

	[ReadOnly]
	int CheckFirstLastCharTheSame();

	[ReadOnly]
	bool StartsWith(char ch);

	[Update]
	int ReplaceChar(char from, char to);
    }
}
