﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;

namespace STMBench7.Core
{

/**
 * STMBench7 benchmark specific exception. Indicates that a benchmark operation
 * failed. Note that operation failures are unavoidable in the benchmark: their
 * number is indicated in the results shown at the end of the benchmark.
 */
[Immutable]
[ThreadLocal]
public class OperationFailedException : Exception {

	public OperationFailedException(String message, Object reportingObject) :
		base(message + " [" + reportingObject.ToString() + "]"){
	}

	public OperationFailedException(String message) :
		base(message){
	}

	public OperationFailedException(String message, Exception cause) :
		base(message, cause){
	}

	public OperationFailedException() {
	}
}

}
