﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Core
{

/**
 * String index key type (immutable).
 */
[Immutable]
public class StringIndexKey : BaseIndexKey {
    
	private readonly String value;

	public StringIndexKey(String value) {
		this.value = value;
	}

    public override int CompareTo(Object otherIndexKey)
    {
        StringIndexKey otherStringIndexKey = (StringIndexKey)otherIndexKey;
        return this.value.CompareTo(otherStringIndexKey.value);

        //char[] a = this.value.ToCharArray;
        //char[] b = otherStringIndexKey.value;
    }

    public override String ToString()
    {
		return value;
	}
}

}
