﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Correctness.Invariants
{
	/**
	 * Test of invariants of an assembly.
	 */
	[Immutable]
	[ThreadLocal]
	public class AssemblyTest : InvariantTest {

		public static void CheckInvariants(Assembly assembly, bool initial, int maxId,
				ComplexAssembly parentAssembly, Module module) {

			DesignObjTest.CheckInvariants(assembly, initial, maxId, Parameters.MinAssmDate, Parameters.MaxAssmDate);
			
			int id = assembly.GetId();
			
			if(assembly.GetSuperAssembly() != parentAssembly)
				ReportError(assembly, id, "invalid reference to the parent ComplexAssembly");
			
			if(assembly.GetModule() != module)
				ReportError(assembly, id, "invalid reference to the parent Module");
		}

	}

}
