﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Correctness.Invariants
{
	/**
	 * Test of invariants of a manual.
	 */
	[Immutable]
	[ThreadLocal]
	public class ManualTest : InvariantTest {

		public static void CheckInvariants(Manual manual, Module module) {
			int id = manual.GetId();
			if(id != 1) ReportError(manual, id, "id", 1, id);
			
			String title = manual.GetTitle(),
				titleShouldBe = "Manual for module #1";
			if(! title.Equals(titleShouldBe))
				ReportError(manual, id, "title", titleShouldBe, title);
			
			if(!manual.StartsWith('I') && !manual.StartsWith('i'))
				ReportError(manual, id, "text (prefix)", "'I' || 'i'", manual.GetText().Substring(0, 7) + " ...");
			
			if(manual.StartsWith('I') && manual.CountOccurences('i') > 0)
				ReportError(manual, id, "text starts from 'I' but contains 'i'");
			
			if(manual.StartsWith('i') && manual.CountOccurences('I') > 0)
				ReportError(manual, id, "text starts from 'i' but contains 'I'");
			
			if(manual.GetModule() != module)
				ReportError(manual, id, "invalid connection to Module");
		}
	}

}
