﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Correctness.Invariants
{
	/**
	 * Test of invariants of the module. Starts a recursive
	 * invariant check down the whole data structure.
	 */
	[Immutable]
	[ThreadLocal]
	public class ModuleTest : InvariantTest {

		public static void CheckInvariants(Module module, bool initial, TraversedObjects traversedObjects) {
			DesignObjTest.CheckInvariants(module, initial, 1, Parameters.MinModuleDate, Parameters.MaxModuleDate);
			
			int id = module.GetId();
			Manual manual = module.GetManual();
			if(manual == null) ReportError(module, id, "Null manual in a module");
			ManualTest.CheckInvariants(manual, module);
			
			ComplexAssembly rootAssembly = module.GetDesignRoot();
			if(rootAssembly == null) ReportError(module, id, "Null root assembly");
			ComplexAssemblyTest.CheckInvariants(rootAssembly, initial, null, module, traversedObjects);
		}
	}

}
