﻿using System;
 
 
using System.Text;
using STMBench7.Backend;
using STMBench7.Compatability;

namespace STMBench7.Impl.Backend
{
	/**
	 * Implements methods that create objects implementing
	 * interfaces defined in stmbench7.backend: Index, IdPool,
	 * and LargeSet. This default implementation constructs
	 * objects that are NOT thread-safe. 
	 */
	public class BackendFactoryImpl : BackendFactory {

		public override LargeSet CreateLargeSet() {
			return new LargeSetImpl();
		}

		public override Index CreateIndex() {
			return new TreeMapIndex();
		}

		public override IdPool CreateIdPool(int maxNumberOfIds) {
			return new IdPoolImpl(maxNumberOfIds);
		}
	}

}
