﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Core;
using STMBench7.Backend;
using STMBench7.Compatability;
using STMBench7.Impl.Backend;

namespace STMBench7.Impl.Core
{

	/**
	 * STMBench7 benchmark Base Assembly (see the specification).
	 * Default implementation.
	 */
	public class BaseAssemblyImpl : AssemblyImpl , BaseAssembly {

	    private BagImpl/*<CompositePart>*/ components;

        public BaseAssemblyImpl(int id, String type, int buildDate, Module module, ComplexAssembly superAssembly)
            : base(id, type, buildDate, module, superAssembly)
        {
			components = new BagImpl/*<CompositePart>*/();
	    }

	    public BaseAssemblyImpl(BaseAssemblyImpl source) : base(source) {
	    	this.components = new BagImpl/*<CompositePart>*/(source.components);
	    }

        public virtual void AddComponent(CompositePart component)
        {
	    	components.Add(component);
	    	component.AddAssembly(this);
	    }

        public virtual bool RemoveComponent(CompositePart component)
        {
	    	bool componentExists = components.BRemove(component);
	    	if(! componentExists) return false;
	    	
	    	component.RemoveAssembly(this);
	    	return true;
	    }

        public virtual ImmutableCollection/*<CompositePart>*/ GetComponents()
        {
	    	return new ImmutableCollectionImpl/*<CompositePart>*/(components);
	    }
	    
        public override void ClearPointers()
        {
	    	base.ClearPointers();
	    	components = null;
	    }
	}

}
