﻿using System;
 
 
using System.Text;

using STMBench7.Core;

namespace STMBench7.Impl.Core
{

	/**
	 * STMBench7 benchmark Connection (see the specification).
	 * Default implementation.
	 */
	public class ConnectionImpl : Connection {

	    protected readonly String type;
	    protected readonly int length;
	    protected readonly AtomicPart from, to;

	    public ConnectionImpl(AtomicPart from, AtomicPart to, String type, int length) {
	    	this.type = type;
	    	this.length = length;
	    	this.from = from;
	    	this.to = to;
	    }

        public virtual Connection GetReversed()
        {
	    	return new ConnectionImpl(to, from, (String)type.Clone(), length);
	    }

        public virtual AtomicPart GetSource()
        {
			return from;
		}

        public virtual AtomicPart GetDestination()
        {
	    	return to;
	    }

        public virtual int GetLength()
        {
			return length;
		}

        public virtual String GetType()
        {
			return type;
		}
	}

}
