﻿using System;
 
 
using System.Text;

using STMBench7.Core;

namespace STMBench7.Impl.Core
{

	/**
	 * STMBench7 benchmark Module (see the specification).
	 * Default implementation.
	 */
	public class ModuleImpl : DesignObjImpl , Module {

	    private readonly Manual man;
	    private ComplexAssembly designRoot;

	    public ModuleImpl(int id, String type, int buildDate, Manual man)
            : base(id, type, buildDate)
        {
	    	this.man = man;
	    	man.SetModule(this);
	    }

        public ModuleImpl(ModuleImpl source)
            : base(source)
        {
	    	this.man = source.man;
	    	this.designRoot = source.designRoot;
	    }

        public virtual void SetDesignRoot(ComplexAssembly designRoot)
        {
	    	this.designRoot = designRoot;
	    }

        public virtual ComplexAssembly GetDesignRoot()
        {
	    	return designRoot;
	    }

        public virtual Manual GetManual()
        {
	    	return man;
	    }
	}

}
