﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Core;
using STMBench7.Backend;
using STMBench7.Impl.Backend;
using STMBench7.Impl.Core;

namespace STMBench7.Impl
{
	/**
	 * An initializer that provides non-thread-safe (default)
	 * factories. Should normally be used only with a single thread.
	 */
	[Immutable]
	public class NoSynchronizationInitializer : SynchMethodInitializer {

        public virtual BackendFactory CreateBackendFactory()
        {
			return new BackendFactoryImpl();
		}

        public virtual DesignObjFactory CreateDesignObjFactory()
        {
			return new DesignObjFactoryImpl();
		}

        public virtual OperationExecutorFactory CreateOperationExecutorFactory()
        {
			return new DefaultOperationExecutorFactory();
		}
	}

}
