﻿using System;


using System.Text;
using System.Threading;
using STMBench7.Core;
using STMBench7.Operations;

namespace STMBench7.Locking
{
    public class STMOperationExecutor : OperationExecutor
    {
        private int lastOperationTimestamp = 0;
        private static int globalCounter = 0;
        private static Object counterLock = new Object();

        private readonly Operation op;

        public STMOperationExecutor(Operation op)
        {
            this.op = op;
        }

        public Object[] function()
        {
            Object[] o = new Object[100];
            return o;
        }
        public int Execute()
        {
            int result = 13371337;
#if STM    
           //Console.WriteLine("Start transaction");

            try
            {
                result = op.PerformOperation();

            }
            catch (AtomicFakeException ex)  //makes this a transaction in Bartok
            {
            }
            finally
            {
                //Console.WriteLine("End transaction");
                lock (counterLock) { lastOperationTimestamp = globalCounter++; }
            }
#else
            throw new Exception("STM support not available");
#endif

            return result;
        }


        public int GetLastOperationTimestamp()
        {
            return lastOperationTimestamp;
        }

    }
}
