﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Operations
{

	/**
	 * Operation OP11 (see the specification).
	 * Simple update.
	 */
	public class Operation11 : Traversal8 {

        public Operation11(Setup oo7setup)
            : base(oo7setup)
        {
		}
		
		[Transactional] [Update]
        public override int PerformOperation()
        {
            return base.PerformOperation();
            
		}
		
        //[BartokSTMExtensions.NoLog]
        protected override int Traverse(Manual manual)
        {
			if(manual.StartsWith('I')) return manual.ReplaceChar('I', 'i');
			if(manual.StartsWith('i')) return manual.ReplaceChar('i', 'I');
			
			throw new RuntimeError("OP11: unexpected Manual.text!");
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.OP11;
	    }
	}

}
