﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Operations
{
	/**
	 * Operation OP12 (see the specification).
	 * Simple update, search on index.
	 */
	public class Operation12 : Operation6 {

        public Operation12(Setup oo7setup)
            : base(oo7setup)
        {
		}
	    
		[Transactional] [Update]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}
	    
        protected override void PerformOperationInComplexAssembly(ComplexAssembly assembly)
        {
			assembly.UpdateBuildDate();
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.OP12;
	    }
	}

}
