﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Core;
using STMBench7.Compatability;

namespace STMBench7.Operations
{

	/**
	 * Operation OP13 (see the specification).
	 * Simple update, search on index.
	 */
	public class Operation13 : Operation7 {

        public Operation13(Setup oo7setup)
            : base(oo7setup)
        {
		}
	    
		[Transactional] [Update]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}
	    
       protected override void PerformOperationInBaseAssembly(BaseAssembly assembly)
        {
			assembly.UpdateBuildDate();
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.OP13;
	    }
	}

}
