﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Annotations;
using STMBench7.Compatability;

namespace STMBench7.Operations
{

	/**
	 * Operation OP9 (see the specification).
	 * Simple update, search on index.
	 */
	public class Operation9 : Query1 {

        public Operation9(Setup oo7setup)
            : base(oo7setup)
        {
		}
	    
		[Transactional] [Update]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}
		
        protected override void PerformOperationInAtomicPart(AtomicPart atomicPart)
        {
			atomicPart.SwapXY();
		}
        
        public override OperationId GetOperationId()
        {
	    	return OperationId.OP9;
	    }
	}

}
