﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Core;
using STMBench7.Annotations;

namespace STMBench7.Operations
{
	/**
	 * Short traversal ST10 (see the specification).
	 * Simple update, short.
	 */
	public class ShortTraversal10 : ShortTraversal9 {

        public ShortTraversal10(Setup oo7setup)
            : base(oo7setup)
        {
		}
	    
		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}

	    [BartokSTMExtensions.NoLog]
        protected override int PerformOperationInAtomicPart(AtomicPart part)
        {
			part.SwapXY();
			return 1;
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.ST10;
	    }
	}

}
