﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Core;

namespace STMBench7.Operations
{
	/**
	 * Short traversal ST2 (see the specification).
	 * Read-only, short.
	 */
	public class ShortTraversal2 : ShortTraversal1 {

		public ShortTraversal2(Setup oo7setup) : base(oo7setup) {
			//base(oo7setup);
		}

        [BartokSTMExtensions.NoLog]
        protected override int Traverse(CompositePart component)
        {
			Document documentation = component.GetDocumentation();
			return Traverse(documentation);
		}

        [BartokSTMExtensions.NoLog]
        protected virtual int Traverse(Document documentation)
        {
			return documentation.SearchText('I');
		}

        [BartokSTMExtensions.NoLogTrans]
        protected override int Traverse(AtomicPart atomicPart)
        {
			throw new RuntimeError("ST2: unexpected call to traverse(AtomicPart)!");
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.ST2;
	    }
	}

}
