﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Annotations;
using STMBench7.Compatability;

namespace STMBench7.Operations
{
	/**
	 * Short traversal ST7 (see the specification).
	 * Simple update, short.
	 */
	public class ShortTraversal7 : ShortTraversal2 {

        public ShortTraversal7(Setup oo7setup)
            : base(oo7setup)
        {
		}
		
		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}
	   
        [BartokSTMExtensions.NoLog]
        protected override int Traverse(Document documentation)
        {
			if(documentation.TextBeginsWith("I am")) return documentation.ReplaceText("I am", "This is");
			if(documentation.TextBeginsWith("This is")) return documentation.ReplaceText("This is", "I am");
			
			throw new RuntimeError("ST7: unexpected beginning of Document.text!");
		}
	    
        public override OperationId GetOperationId()
        {
	    	return OperationId.ST7;
	    }
	}

}
