﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Compatability;
using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Operations
{
	/**
	 * Structural modification operation SM2 (see the specification).
	 */
	public class StructuralModification2 : StructuralModification1 {

		protected Index/*<IntIndexKey, CompositePart>*/ compositePartIdIndex;

        public StructuralModification2(Setup oo7setup)
            : base(oo7setup)
        {
			this.compositePartIdIndex = oo7setup.GetCompositePartIdIndex();
		}

		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
			int partToRemoveId = ThreadRandom.NextInt(Parameters.MaxCompParts) + 1;
			CompositePart partToRemove = (CompositePart)compositePartIdIndex.Get(new IntIndexKey(partToRemoveId));
			if(partToRemove == null) throw new OperationFailedException();
			
			compositePartBuilder.UnregisterAndRecycleCompositePart(partToRemove);
			return 0;
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.SM2;
	    }
	}

}
