﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Core;
using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Operations
{
	/**
	 * Traversal T3, variant (a) (see the specification).
	 * Simple update, update on index, long.
	 */
	public class Traversal3a : Traversal1 {

		Index/*<IntIndexKey,LargeSet<AtomicPart>>*/ partBuildDateIndex;

        public Traversal3a(Setup oo7setup)
            : base(oo7setup)
        {
			this.partBuildDateIndex = oo7setup.GetAtomicPartBuildDateIndex();
		}

		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}

        [BartokSTMExtensions.NoLog]
        protected override int PerformOperationInAtomicPart(AtomicPart part, HashtableSet/*<AtomicPart>*/ setOfVisitedPartIds)
        {
			if(setOfVisitedPartIds.Count==0) {
				UpdateBuildDate(part);
				return 1;
			}

			part.NullOperation();
			return 0;
		}

        [BartokSTMExtensions.NoLog]
        protected virtual void UpdateBuildDate(AtomicPart part)
        {
			RemoveAtomicPartFromBuildDateIndex(partBuildDateIndex, part);
			part.UpdateBuildDate();
			AddAtomicPartToBuildDateIndex(partBuildDateIndex, part);
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.T3a;
	    }
	}


}
