﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Core;
using STMBench7.Backend;

namespace STMBench7
{
	/**
	 * Creates factories suitable for a given synchonization method.
	 * Default implementations are provided for coarse-grained and
	 * medium-grained locking, as well as for single-threaded executions
	 * (i.e., without any thread synchronization).
	 */
	[NonAtomic]
	public interface SynchMethodInitializer {

		DesignObjFactory CreateDesignObjFactory();
		BackendFactory CreateBackendFactory();
		OperationExecutorFactory CreateOperationExecutorFactory();
	}

}
